tests: use printf, not echo in init.sh's warn_ function
[gnulib.git] / tests / init.sh
1 # source this file; set up for tests
2
3 # Copyright (C) 2009-2011 Free Software Foundation, Inc.
4
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 # Using this file in a test
19 # =========================
20 #
21 # The typical skeleton of a test looks like this:
22 #
23 #   #!/bin/sh
24 #   . "${srcdir=.}/init.sh"; path_prepend_ .
25 #   Execute some commands.
26 #   Note that these commands are executed in a subdirectory, therefore you
27 #   need to prepend "../" to relative filenames in the build directory.
28 #   Note that the "path_prepend_ ." is useful only if the body of your
29 #   test invokes programs residing in the initial directory.
30 #   For example, if the programs you want to test are in src/, and this test
31 #   script is named tests/test-1, then you would use "path_prepend_ ../src",
32 #   or perhaps export PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH"
33 #   to all tests via automake's TESTS_ENVIRONMENT.
34 #   Set the exit code 0 for success, 77 for skipped, or 1 or other for failure.
35 #   Use the skip_ and fail_ functions to print a diagnostic and then exit
36 #   with the corresponding exit code.
37 #   Exit $?
38
39 # Executing a test that uses this file
40 # ====================================
41 #
42 # Running a single test:
43 #   $ make check TESTS=test-foo.sh
44 #
45 # Running a single test, with verbose output:
46 #   $ make check TESTS=test-foo.sh VERBOSE=yes
47 #
48 # Running a single test, with single-stepping:
49 #   1. Go into a sub-shell:
50 #   $ bash
51 #   2. Set relevant environment variables from TESTS_ENVIRONMENT in the
52 #      Makefile:
53 #   $ export srcdir=../../tests # this is an example
54 #   3. Execute the commands from the test, copy&pasting them one by one:
55 #   $ . "$srcdir/init.sh"; path_prepend_ .
56 #   ...
57 #   4. Finally
58 #   $ exit
59
60 ME_=`expr "./$0" : '.*/\(.*\)$'`
61
62 # We use a trap below for cleanup.  This requires us to go through
63 # hoops to get the right exit status transported through the handler.
64 # So use `Exit STATUS' instead of `exit STATUS' inside of the tests.
65 # Turn off errexit here so that we don't trip the bug with OSF1/Tru64
66 # sh inside this function.
67 Exit () { set +e; (exit $1); exit $1; }
68
69 # Print warnings (e.g., about skipped and failed tests) to this file number.
70 # Override by defining to say, 9, in init.cfg, and putting say,
71 #   export ...ENVVAR_SETTINGS...; $(SHELL) 9>&2
72 # in the definition of TESTS_ENVIRONMENT in your tests/Makefile.am file.
73 # This is useful when using automake's parallel tests mode, to print
74 # the reason for skip/failure to console, rather than to the .log files.
75 : ${stderr_fileno_=2}
76
77 # Note that correct expansion of "$*" depends on IFS starting with ' '.
78 # Always write the full diagnostic to stderr.
79 # When stderr_fileno_ is not 2, also emit the first line of the
80 # diagnostic to that file descriptor.
81 warn_ ()
82 {
83   # If IFS does not start with ' ', set it and emit the warning in a subshell.
84   case $IFS in
85     ' '*) printf '%s\n' "$*" >&2
86           test $stderr_fileno_ = 2 \
87             || { printf '%s\n' "$*" | sed 1q >&$stderr_fileno_ ; } ;;
88     *) (IFS=' '; warn_ "$@");;
89   esac
90 }
91 fail_ () { warn_ "$ME_: failed test: $@"; Exit 1; }
92 skip_ () { warn_ "$ME_: skipped test: $@"; Exit 77; }
93 fatal_ () { warn_ "$ME_: hard error: $@"; Exit 99; }
94 framework_failure_ () { warn_ "$ME_: set-up failure: $@"; Exit 99; }
95
96 # Sanitize this shell to POSIX mode, if possible.
97 DUALCASE=1; export DUALCASE
98 if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
99   emulate sh
100   NULLCMD=:
101   alias -g '${1+"$@"}'='"$@"'
102   setopt NO_GLOB_SUBST
103 else
104   case `(set -o) 2>/dev/null` in
105     *posix*) set -o posix ;;
106   esac
107 fi
108
109 # We require $(...) support unconditionally.
110 # We require a few additional shell features only when $EXEEXT is nonempty,
111 # in order to support automatic $EXEEXT emulation:
112 # - hyphen-containing alias names
113 # - we prefer to use ${var#...} substitution, rather than having
114 #   to work around lack of support for that feature.
115 # The following code attempts to find a shell with support for these features.
116 # If the current shell passes the test, we're done.  Otherwise, test other
117 # shells until we find one that passes.  If one is found, re-exec it.
118 # If no acceptable shell is found, skip the current test.
119 #
120 # The "...set -x; P=1 true 2>err..." test is to disqualify any shell that
121 # emits "P=1" into err, as /bin/sh from SunOS 5.11 and OpenBSD 4.7 do.
122 #
123 # Use "9" to indicate success (rather than 0), in case some shell acts
124 # like Solaris 10's /bin/sh but exits successfully instead of with status 2.
125
126 # Eval this code in a subshell to determine a shell's suitability.
127 # 10 - passes all tests; ok to use
128 #  9 - ok, but enabling "set -x" corrupts app stderr; prefer higher score
129 #  ? - not ok
130 gl_shell_test_script_='
131 test $(echo y) = y || exit 1
132 score_=10
133 if test "$VERBOSE" = yes; then
134   test -n "$( (exec 3>&1; set -x; P=1 true 2>&3) 2> /dev/null)" && score_=9
135 fi
136 test -z "$EXEEXT" && exit $score_
137 shopt -s expand_aliases
138 alias a-b="echo zoo"
139 v=abx
140      test ${v%x} = ab \
141   && test ${v#a} = bx \
142   && test $(a-b) = zoo \
143   && exit $score_
144 '
145
146 if test "x$1" = "x--no-reexec"; then
147   shift
148 else
149   # Assume a working shell.  Export to subshells (setup_ needs this).
150   gl_set_x_corrupts_stderr_=false
151   export gl_set_x_corrupts_stderr_
152
153   # Record the first marginally acceptable shell.
154   marginal_=
155
156   # Search for a shell that meets our requirements.
157   for re_shell_ in __current__ "${CONFIG_SHELL:-no_shell}" \
158       /bin/sh bash dash zsh pdksh fail
159   do
160     test "$re_shell_" = no_shell && continue
161
162     # If we've made it all the way to the sentinel, "fail" without
163     # finding even a marginal shell, skip this test.
164     if test "$re_shell_" = fail; then
165       test -z "$marginal_" && skip_ failed to find an adequate shell
166       re_shell_=$marginal_
167       break
168     fi
169
170     # When testing the current shell, simply "eval" the test code.
171     # Otherwise, run it via $re_shell_ -c ...
172     if test "$re_shell_" = __current__; then
173       # 'eval'ing this code makes Solaris 10's /bin/sh exit with
174       # $? set to 2.  It does not evaluate any of the code after the
175       # "unexpected" first `('.  Thus, we must run it in a subshell.
176       ( eval "$gl_shell_test_script_" ) > /dev/null 2>&1
177     else
178       "$re_shell_" -c "$gl_shell_test_script_" 2>/dev/null
179     fi
180
181     st_=$?
182
183     # $re_shell_ works just fine.  Use it.
184     if test $st_ = 10; then
185       gl_set_x_corrupts_stderr_=false
186       break
187     fi
188
189     # If this is our first marginally acceptable shell, remember it.
190     if test "$st_:$marginal_" = 9: ; then
191       marginal_="$re_shell_"
192       gl_set_x_corrupts_stderr_=true
193     fi
194   done
195
196   if test "$re_shell_" != __current__; then
197     # Found a usable shell.  Preserve -v and -x.
198     case $- in
199       *v*x* | *x*v*) opts_=-vx ;;
200       *v*) opts_=-v ;;
201       *x*) opts_=-x ;;
202       *) opts_= ;;
203     esac
204     exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
205     echo "$ME_: exec failed" 1>&2
206     exit 127
207   fi
208 fi
209
210 test -n "$EXEEXT" && shopt -s expand_aliases
211
212 # Enable glibc's malloc-perturbing option.
213 # This is useful for exposing code that depends on the fact that
214 # malloc-related functions often return memory that is mostly zeroed.
215 # If you have the time and cycles, use valgrind to do an even better job.
216 : ${MALLOC_PERTURB_=87}
217 export MALLOC_PERTURB_
218
219 # This is a stub function that is run upon trap (upon regular exit and
220 # interrupt).  Override it with a per-test function, e.g., to unmount
221 # a partition, or to undo any other global state changes.
222 cleanup_ () { :; }
223
224 if ( diff -u "$0" "$0" < /dev/null ) > /dev/null 2>&1; then
225   compare () { diff -u "$@"; }
226 elif ( diff -c "$0" "$0" < /dev/null ) > /dev/null 2>&1; then
227   compare () { diff -c "$@"; }
228 elif ( cmp --version < /dev/null 2>&1 | grep GNU ) > /dev/null 2>&1; then
229   compare () { cmp -s "$@"; }
230 else
231   compare () { cmp "$@"; }
232 fi
233
234 # An arbitrary prefix to help distinguish test directories.
235 testdir_prefix_ () { printf gt; }
236
237 # Run the user-overridable cleanup_ function, remove the temporary
238 # directory and exit with the incoming value of $?.
239 remove_tmp_ ()
240 {
241   __st=$?
242   cleanup_
243   # cd out of the directory we're about to remove
244   cd "$initial_cwd_" || cd / || cd /tmp
245   chmod -R u+rwx "$test_dir_"
246   # If removal fails and exit status was to be 0, then change it to 1.
247   rm -rf "$test_dir_" || { test $__st = 0 && __st=1; }
248   exit $__st
249 }
250
251 # Given a directory name, DIR, if every entry in it that matches *.exe
252 # contains only the specified bytes (see the case stmt below), then print
253 # a space-separated list of those names and return 0.  Otherwise, don't
254 # print anything and return 1.  Naming constraints apply also to DIR.
255 find_exe_basenames_ ()
256 {
257   feb_dir_=$1
258   feb_fail_=0
259   feb_result_=
260   feb_sp_=
261   for feb_file_ in $feb_dir_/*.exe; do
262     # If there was no *.exe file, or there existed a file named "*.exe" that
263     # was deleted between the above glob expansion and the existence test
264     # below, just skip it.
265     test "x$feb_file_" = "x$feb_dir_/*.exe" && test ! -f "$feb_file_" \
266       && continue
267     # Exempt [.exe, since we can't create a function by that name, yet
268     # we can't invoke [ by PATH search anyways due to shell builtins.
269     test "x$feb_file_" = "x$feb_dir_/[.exe" && continue
270     case $feb_file_ in
271       *[!-a-zA-Z/0-9_.+]*) feb_fail_=1; break;;
272       *) # Remove leading file name components as well as the .exe suffix.
273          feb_file_=${feb_file_##*/}
274          feb_file_=${feb_file_%.exe}
275          feb_result_="$feb_result_$feb_sp_$feb_file_";;
276     esac
277     feb_sp_=' '
278   done
279   test $feb_fail_ = 0 && printf %s "$feb_result_"
280   return $feb_fail_
281 }
282
283 # Consider the files in directory, $1.
284 # For each file name of the form PROG.exe, create an alias named
285 # PROG that simply invokes PROG.exe, then return 0.  If any selected
286 # file name or the directory name, $1, contains an unexpected character,
287 # define no alias and return 1.
288 create_exe_shims_ ()
289 {
290   case $EXEEXT in
291     '') return 0 ;;
292     .exe) ;;
293     *) echo "$0: unexpected \$EXEEXT value: $EXEEXT" 1>&2; return 1 ;;
294   esac
295
296   base_names_=`find_exe_basenames_ $1` \
297     || { echo "$0 (exe_shim): skipping directory: $1" 1>&2; return 0; }
298
299   if test -n "$base_names_"; then
300     for base_ in $base_names_; do
301       alias "$base_"="$base_$EXEEXT"
302     done
303   fi
304
305   return 0
306 }
307
308 # Use this function to prepend to PATH an absolute name for each
309 # specified, possibly-$initial_cwd_-relative, directory.
310 path_prepend_ ()
311 {
312   while test $# != 0; do
313     path_dir_=$1
314     case $path_dir_ in
315       '') fail_ "invalid path dir: '$1'";;
316       /*) abs_path_dir_=$path_dir_;;
317       *) abs_path_dir_=`cd "$initial_cwd_/$path_dir_" && echo "$PWD"` \
318            || fail_ "invalid path dir: $path_dir_";;
319     esac
320     case $abs_path_dir_ in
321       *:*) fail_ "invalid path dir: '$abs_path_dir_'";;
322     esac
323     PATH="$abs_path_dir_:$PATH"
324
325     # Create an alias, FOO, for each FOO.exe in this directory.
326     create_exe_shims_ "$abs_path_dir_" \
327       || fail_ "something failed (above): $abs_path_dir_"
328     shift
329   done
330   export PATH
331 }
332
333 setup_ ()
334 {
335   if test "$VERBOSE" = yes; then
336     # Test whether set -x may cause the selected shell to corrupt an
337     # application's stderr.  Many do, including zsh-4.3.10 and the /bin/sh
338     # from SunOS 5.11, OpenBSD 4.7 and Irix 5.x and 6.5.
339     # If enabling verbose output this way would cause trouble, simply
340     # issue a warning and refrain.
341     if $gl_set_x_corrupts_stderr_; then
342       warn_ "using SHELL=$SHELL with 'set -x' corrupts stderr"
343     else
344       set -x
345     fi
346   fi
347
348   initial_cwd_=$PWD
349   fail=0
350
351   pfx_=`testdir_prefix_`
352   test_dir_=`mktempd_ "$initial_cwd_" "$pfx_-$ME_.XXXX"` \
353     || fail_ "failed to create temporary directory in $initial_cwd_"
354   cd "$test_dir_"
355
356   # As autoconf-generated configure scripts do, ensure that IFS
357   # is defined initially, so that saving and restoring $IFS works.
358   gl_init_sh_nl_='
359 '
360   IFS=" ""      $gl_init_sh_nl_"
361
362   # This trap statement, along with a trap on 0 below, ensure that the
363   # temporary directory, $test_dir_, is removed upon exit as well as
364   # upon receipt of any of the listed signals.
365   for sig_ in 1 2 3 13 15; do
366     eval "trap 'Exit $(expr $sig_ + 128)' $sig_"
367   done
368 }
369
370 # Create a temporary directory, much like mktemp -d does.
371 # Written by Jim Meyering.
372 #
373 # Usage: mktempd_ /tmp phoey.XXXXXXXXXX
374 #
375 # First, try to use the mktemp program.
376 # Failing that, we'll roll our own mktemp-like function:
377 #  - try to get random bytes from /dev/urandom
378 #  - failing that, generate output from a combination of quickly-varying
379 #      sources and gzip.  Ignore non-varying gzip header, and extract
380 #      "random" bits from there.
381 #  - given those bits, map to file-name bytes using tr, and try to create
382 #      the desired directory.
383 #  - make only $MAX_TRIES_ attempts
384
385 # Helper function.  Print $N pseudo-random bytes from a-zA-Z0-9.
386 rand_bytes_ ()
387 {
388   n_=$1
389
390   # Maybe try openssl rand -base64 $n_prime_|tr '+/=\012' abcd first?
391   # But if they have openssl, they probably have mktemp, too.
392
393   chars_=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
394   dev_rand_=/dev/urandom
395   if test -r "$dev_rand_"; then
396     # Note: 256-length($chars_) == 194; 3 copies of $chars_ is 186 + 8 = 194.
397     dd ibs=$n_ count=1 if=$dev_rand_ 2>/dev/null \
398       | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
399     return
400   fi
401
402   n_plus_50_=`expr $n_ + 50`
403   cmds_='date; date +%N; free; who -a; w; ps auxww; ps ef; netstat -n'
404   data_=` (eval "$cmds_") 2>&1 | gzip `
405
406   # Ensure that $data_ has length at least 50+$n_
407   while :; do
408     len_=`echo "$data_"|wc -c`
409     test $n_plus_50_ -le $len_ && break;
410     data_=` (echo "$data_"; eval "$cmds_") 2>&1 | gzip `
411   done
412
413   echo "$data_" \
414     | dd bs=1 skip=50 count=$n_ 2>/dev/null \
415     | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
416 }
417
418 mktempd_ ()
419 {
420   case $# in
421   2);;
422   *) fail_ "Usage: mktempd_ DIR TEMPLATE";;
423   esac
424
425   destdir_=$1
426   template_=$2
427
428   MAX_TRIES_=4
429
430   # Disallow any trailing slash on specified destdir:
431   # it would subvert the post-mktemp "case"-based destdir test.
432   case $destdir_ in
433   /) ;;
434   */) fail_ "invalid destination dir: remove trailing slash(es)";;
435   esac
436
437   case $template_ in
438   *XXXX) ;;
439   *) fail_ \
440        "invalid template: $template_ (must have a suffix of at least 4 X's)";;
441   esac
442
443   # First, try to use mktemp.
444   d=`unset TMPDIR; mktemp -d -t -p "$destdir_" "$template_" 2>/dev/null` \
445     || fail=1
446
447   # The resulting name must be in the specified directory.
448   case $d in "$destdir_"*);; *) fail=1;; esac
449
450   # It must have created the directory.
451   test -d "$d" || fail=1
452
453   # It must have 0700 permissions.  Handle sticky "S" bits.
454   perms=`ls -dgo "$d" 2>/dev/null|tr S -` || fail=1
455   case $perms in drwx------*) ;; *) fail=1;; esac
456
457   test $fail = 0 && {
458     echo "$d"
459     return
460   }
461
462   # If we reach this point, we'll have to create a directory manually.
463
464   # Get a copy of the template without its suffix of X's.
465   base_template_=`echo "$template_"|sed 's/XX*$//'`
466
467   # Calculate how many X's we've just removed.
468   template_length_=`echo "$template_" | wc -c`
469   nx_=`echo "$base_template_" | wc -c`
470   nx_=`expr $template_length_ - $nx_`
471
472   err_=
473   i_=1
474   while :; do
475     X_=`rand_bytes_ $nx_`
476     candidate_dir_="$destdir_/$base_template_$X_"
477     err_=`mkdir -m 0700 "$candidate_dir_" 2>&1` \
478       && { echo "$candidate_dir_"; return; }
479     test $MAX_TRIES_ -le $i_ && break;
480     i_=`expr $i_ + 1`
481   done
482   fail_ "$err_"
483 }
484
485 # If you want to override the testdir_prefix_ function,
486 # or to add more utility functions, use this file.
487 test -f "$srcdir/init.cfg" \
488   && . "$srcdir/init.cfg"
489
490 setup_ "$@"
491 # This trap is here, rather than in the setup_ function, because some
492 # shells run the exit trap at shell function exit, rather than script exit.
493 trap remove_tmp_ 0